library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

use IEEE.NUMERIC_STD.ALL;

use work.ep9_package.all;

entity Aufgabe3_1 is
  port (
    clock   : in  std_logic;
    
    SW      : in  std_logic_vector(7 downto 0);
    LED     : out std_logic_vector(7 downto 0)
  );
end Aufgabe3_1;

architecture Behavioral of Aufgabe3_1 is
  component sys_pll
  port (-- Clock in ports
    CLK_IN1           : in     std_logic;
    -- Clock out ports
    CLK_OUT_65        : out    std_logic;
    CLK_OUT_25        : out    std_logic;
    CLK_OUT_20        : out    std_logic;
    -- Status and control signals
    RESET             : in     std_logic;
    LOCKED            : out    std_logic
  );
  end component;
  
  signal s_clk65    : std_logic;
  signal s_clk20    : std_logic;
  signal s_locked   : std_logic;
  signal s_reset    : std_logic;
  
  signal r_counter  : unsigned(16 downto 0);
  signal r_LED      : unsigned( 7 downto 0);
  
begin
  
  i_sys_pll : sys_pll
  port map (-- Clock in ports
    CLK_IN1    => clock,
    -- Clock out ports
    CLK_OUT_65 => s_clk65,
    CLK_OUT_25 => open,
    CLK_OUT_20 => s_clk20,
    -- Status and control signals
    RESET      => SW(0),
    LOCKED     => s_locked
  );
  
  s_reset <= not s_locked;
  
  LED <= std_logic_vector(r_LED);
  
  p_counter: process(s_clk20)
  begin
    if rising_edge(s_clk20) then
      if s_reset = '1' then
        r_counter <= to_unsigned(0,17);
        r_LED <= to_unsigned(0,8);
      else
        r_counter <= r_counter + 1;
        if r_counter = c_prescaler - 1 then
          r_counter <= to_unsigned(0,17);
          
          r_LED <= r_LED + 1;
        end if;
        
      end if;
    end if;
  end process;
  
end Behavioral;
